<template>
  <!-- <div class="header_nox">
      <el-button type="warning" circle @click="exportWord">下载</el-button>
      <el-button type="primary" circle v-show="!editable" @click="editable = !editable">编辑</el-button>
      <el-button type="primary" v-show=editable @click="saveData">确定</el-button>
    </div> -->
  <div id="printContent" ref="imageWrapper">
    <h3>冲床日常点检表</h3>
    <div class="title_form">
      <div class="title_form_input">
        <span>生产线：</span>
        <span>{{ headData.head.shengcx }}</span>
      </div>
      <div class="title_form_input">
        <span>产品：</span>
        <span>{{ headData.head.chanpin }}</span>
      </div>
      <div class="title_form_input">
        <span>日期：</span>
        <span>{{ headData.head.reportTime }}</span>
      </div>
      <div class="title_form_input">
        <span>班次：</span>
        <span>{{ headData.head.banci }}</span>
      </div>
      <div class="title_form_input">
        <span>记录员：</span>
        <span>{{ headData.head.jiluyuan }}</span>
      </div>
      <div class="title_form_input">
        <span>接班时间：</span>
        <span>{{ headData.head.jieban1 }}</span>
      </div>
      <div class="title_form_input">
        <span>交班时间：</span>
        <span>{{ headData.head.jiaoban1 }}</span>
      </div>
    </div>
    <el-divider />

    <HJTABLE
      :SClist="c2_checkHeaderData"
      :tableHeader="c2_checkHeader"
      :editable="editable"
    >
    </HJTABLE>
  </div>
</template>

<script>
const item = {
  name: "",
  birth: "",
  province: "",
  city: "",
  address: "",
  phone: "",
};
const header = {
  prop: "key",
  label: "自定义",
  editable: false,
  type: "input",
};
import { ref, reactive, onMounted } from "vue";
import { ElMessage } from "element-plus";
import { chong02VoLast, chong02VoSave } from "@/api/gaixian";
import html2canvas from "html2canvas";
import docxtemplater from "docxtemplater";
import PizZip from "pizzip";
import JSZipUtils from "jszip-utils";
import { saveAs } from "file-saver";
import HJTABLE from "@/components/arj/arj-table";
import { useRouter } from "vue-router";
import { headReport } from "@/api/head";
export default {
  name: "",
  components: { HJTABLE },
  props: {},
  setup(props) {
    const router = useRouter();
    const c2_checkHeader = reactive([
      { prop: "no", label: "序号", editable: "false", type: "text" },
      { prop: "sbbw", label: "设备部位", editable: "false", type: "text" },
      { prop: "gj", label: "工具", editable: "false", type: "text" },
      { prop: "banci", label: "班次", editable: "false", type: "text" },
      { prop: "pdbz", label: "判断标准", editable: "false", type: "text" },
      { prop: "shijian", label: "时间", editable: "false", type: "text" },
      { prop: "t1", label: "1", editable: "false", type: "text" },
      { prop: "t2", label: "2", editable: "false", type: "text" },
      { prop: "t3", label: "3", editable: "false", type: "text" },
      { prop: "t4", label: "4", editable: "false", type: "text" },
      { prop: "t5", label: "5", editable: "false", type: "text" },
      { prop: "t6", label: "6", editable: "false", type: "text" },
      { prop: "t7", label: "7", editable: "false", type: "text" },
      { prop: "t8", label: "8", editable: "false", type: "text" },
      { prop: "t9", label: "9", editable: "false", type: "text" },
      { prop: "t10", label: "10", editable: "false", type: "text" },
      { prop: "t11", label: "11", editable: "false", type: "text" },
      { prop: "t12", label: "12", editable: "false", type: "text" },
      { prop: "t13", label: "13", editable: "false", type: "text" },
      { prop: "t14", label: "14", editable: "false", type: "text" },
      { prop: "t15", label: "15", editable: "false", type: "text" },
      { prop: "t16", label: "16", editable: "false", type: "text" },
      { prop: "t17", label: "17", editable: "false", type: "text" },
      { prop: "t18", label: "18", editable: "false", type: "text" },
      { prop: "t19", label: "19", editable: "false", type: "text" },
      { prop: "t20", label: "20", editable: "false", type: "text" },
      { prop: "t21", label: "21", editable: "false", type: "text" },
      { prop: "t22", label: "22", editable: "false", type: "text" },
      { prop: "t23", label: "23", editable: "false", type: "text" },
      { prop: "t24", label: "24", editable: "false", type: "text" },
      { prop: "t25", label: "25", editable: "false", type: "text" },
      { prop: "t26", label: "26", editable: "false", type: "text" },
      { prop: "t27", label: "27", editable: "false", type: "text" },
      { prop: "t28", label: "28", editable: "false", type: "text" },
      { prop: "t29", label: "29", editable: "false", type: "text" },
      { prop: "t30", label: "30", editable: "false", type: "text" },
      { prop: "t31", label: "31", editable: "false", type: "text" },
    ]);
    let tableData = reactive([]);
    const formInline = reactive({
      user: "",
      region: "",
    });
    const imageWrapper = ref(null);

    let headData = reactive({
      head: {},
    });

    let labelName = {
      b1: "铁使用情况",
      b2: "生产速度与压力",
      b3: "基本尺寸",
      b4: "外观检测项目",
    };
    let editable = ref(false);

    let SClist = ref([]);
    let hjData = ref({});

    let c2_checkHeaderData = ref([]);

    const submitForm = () => {};

    const handleEdit = (row) => {
      row.editable = true;
    };
    const handleDelete = (index) => {
      this.tableData.splice(index, 1);
    };
    const prepend = (index) => {
      item.editable = true;
      this.tableData.splice(index, 0, item);
    };
    const append = (index) => {
      item.editable = true;
      this.tableData.splice(index + 1, 0, item);
    };
    const deleteCurrentColumn = (index) => {
      this.tableHeader.splice(index, 1);
    };
    const insertBefore = (index) => {
      header.editable = true;
      this.tableHeader.splice(index, 0, header);
    };

    const getListData = async () => {
      const data = await chong02VoLast();

      parse(data);
    };
    function parse(data) {
      console.log(".........", data);
      headData.head = data.data.head;
      if (headData.head.reportTime != null)
        headData.head.reportTime = headData.head.reportTime.substr(0, 10);
      // headData.head.reportTime = headData.head.reportTime.substr(0, 10);
      // headData.head.jieban1 = headData.head.jieban.substr(11, 5);
      // headData.head.jiaoban1 = headData.head.jiaoban.substr(11, 5);
      c2_checkHeaderData.value = data.data.c2CheckList;

      hjData.value = {
        ...headData.head,
      };
    }
    const saveData = async () => {
      editable = false;
      let data = {
        head: headData.head,
        c2CheckList: c2_checkHeaderData.value,
      };
      console.log("save data...", data);
      const dt = await chong02VoSave(data);
      if (dt.code == 0) {
        ElMessage({
          message: "修改成功",
          type: "success",
        });
      }
      console.log(dt);
    };
    //截图
    const toImage = () => {
      html2canvas(imageWrapper.value, {
        logging: false,
        allowTaint: true,
        scale: window.devicePixelRatio,
        // width: shareContent.clientWidth, //dom 原始宽度
        // height: shareContent.clientHeight,
        scrollY: 0,
        scrollX: 0,
        useCORS: true,
        backgroundColor: "#ffffff",
      }).then(function (canvas) {
        // console.log(canvas);
        let imgUrl = canvas.toDataURL("image/png");
        var tempLink = document.createElement("a"); // 创建一个a标签
        tempLink.style.display = "none";
        tempLink.href = imgUrl;
        tempLink.setAttribute("download", "罐线生产情况报表"); // 给a标签添加下载属性
        if (typeof tempLink.download === "undefined") {
          tempLink.setAttribute("target", "_blank");
        }
        document.body.appendChild(tempLink); // 将a标签添加到body当中
        tempLink.click(); // 启动下载
        document.body.removeChild(tempLink); // 下载完毕删除a标签
        window.URL.revokeObjectURL(imgUrl);
      });
    };
    // 点击导出word
    function exportWord() {
      // 读取并获得模板文件的二进制内容
      JSZipUtils.getBinaryContent("g02.docx", function (error, content) {
        // input.docx是模板。我们在导出的时候，会根据此模板来导出对应的数据
        // 抛出异常
        if (error) {
          throw error;
        }

        // 创建一个JSZip实例，内容为模板的内容
        let zip = new PizZip(content);
        // 创建并加载docxtemplater实例对象

        let doc = new docxtemplater().loadZip(zip).setOptions({
          nullGetter: function () {
            return "";
          },
        });
        // 设置模板变量的值
        doc.setData({
          ...hjData.value,
          t1: c2_checkHeaderData.value,
        });

        try {
          // 用模板变量的值替换所有模板变量
          doc.render();
        } catch (error) {
          // 抛出异常
          let e = {
            message: error.message,
            name: error.name,
            stack: error.stack,
            properties: error.properties,
          };
          console.log(JSON.stringify({ error: e }));
          throw error;
        }

        // 生成一个代表docxtemplater对象的zip文件（不是一个真实的文件，而是在内存中的表示）
        let out = doc.getZip().generate({
          type: "blob",
          mimeType:
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
        });
        // 将目标文件对象保存为目标类型的文件，并命名
        saveAs(out, "冲床日常点检表.docx");
      });
    }
    const getRouterData = async (req) => {
      console.log("req....", req);
      const data = await headReport(req);
      console.log("jbj router data.....", data);

      parse(data);
    };
    onMounted(() => {
      console.log("rrrrrrrrrrr", router.currentRoute.value.query);
      let head_id = router.currentRoute.value.query.id;
      let leixing = router.currentRoute.value.query.leixing;
      console.log("vue recv....", head_id, leixing);
      if (head_id == null) {
        getListData();
      } else {
        getRouterData({ head_id: head_id, leixing: leixing });
      }
    });
    return {
      saveData,
      submitForm,
      formInline,
      tableData,
      insertBefore,
      deleteCurrentColumn,
      append,
      prepend,
      handleDelete,
      handleEdit,
      editable,
      getListData,
      headData,
      toImage,
      imageWrapper,
      labelName,
      exportWord,
      c2_checkHeaderData,
      c2_checkHeader,
      chong02VoLast,
      chong02VoSave,
    };
  },
};
</script>
<style lang="scss" scoped>
.header_nox {
  text-align: right;
}

#printContent h3 {
  text-align: center;
  margin-bottom: 40px;
  font-size: 26px;
  font-weight: bold;
}

.title_form {
  display: flex;
  justify-content: space-around;
  align-items: center;
  // margin-bottom: 20px;
}

.title_form_input {
  font-size: 16px;
}
</style>
